Subject: Re: your mail

From: Zheng Gengbing <[email-masked]>
Date: Tue, 2 Jul 1996 11:45:55 +0800 (EAT)

On Mon, 1 Jul 1996, Guansong Zhang wrote:

> On Jul 2, 10:39am, Zheng Gengbing wrote:
> > Subject: Re: your mail
> >
> > On Mon, 1 Jul 1996, Guansong Zhang wrote:
> >
> > > On Jul 2, 10:21am, Zheng Gengbing wrote:
> > > > Subject: Re: your mail
> > > > On Mon, 1 Jul 1996, Guansong Zhang wrote:
> > > >
> > > > > I need some organization information from you to complete the test on
> our
> > > > > frontend.
> > > > >
> > > > > Right now I am not sure about semantics checking. So please give me
> some
> > > help
> > > > > on this.
> > > > >
> > > > > The attached is a latex file of summary on testing. I need detailed
> info on
> > > > > semantics checking. Some one here also are interested in developing a
> > > complete
> > > > > semantics checking like the thing was done in sytax checking.
> > > > >
> > > > > I think if we organize the semantics testing a little more clearly, our
> > > work
> > > > > can serve the purpose. So I hope you do not overlook this work. It is
> as
> > > > > important as code writing.
> > > > >
> > > >
> > > > >
> > > > 	I have conducted a little work about this . I am writing samples
> > > > according to the constrains of every rules .
> > > >
> > > > 	But this work is very tedious . And I don't think to have a complete
> > > > semantics checking like sytax checking can also prove the correctness of
> the
> > > > hpfsc .
> > > >
> > > > 	If you are intrested on this , I will give you  this sample files.
> > > >
> > > >
> > > >
> > > > Gengbin
> > > >-- End of excerpt from Zheng Gengbing
> > >
> > > I have same idea with you. But the people here do not think so. I think if
> we
> > > can check each constrains of every rule will be a complete enough one.
> > >
> > > So please give me as much info on this as you can. Let's show them that we
> had
> > > a complete ENOUGH semantics checking.
> > >
> > > Guansong
> > >
> >
> >
> > 	Due to the AST representation , I believe sometimes hpfsc can report
> > errors correctly , and sometimes(in some circumstance) incorrectly . So only
> > one sample cannot tell if the checking is correct .
> >
> >
> > 	here , I will attach an example on how I orgnize the samples
> >
> > Gengbin
> >
> >-- End of excerpt from Zheng Gengbing
> 
> 
> I don't understand this well. I need more time to see the examples. Tonight, I
> have to finish another program.
> 
> But could you tell me how many contrains in syntax rule? and how many are
> tested in our testsuite/semantics? How are they seperated in different files?
>

	I have not counted that . Maybe hundreds of them . I will say more
than half of them are tested in our testsuite . I separated them according
to a f90 book . Since in most cases several rules are only to express one 
thing togather , like derived type declaration . So I integrated them in
one file.
	I am still improving this testsuite in spare time , and there seems
still a lot of work to orginized them . And if some errors of hpfsc 
occurs during checking , I have to turn to solve them . So the progress is
a little slow . After I wrote every file , I also make a compare with the
result of xlf90 on IBM RS6000 to make sure if our comprehension is 
correct . 

> Semantics checking before actual compiling has its advantage, which make the
> AST more accurate. But I think it also must has its disadvantage, say some of
> the checking may too difficult or impossible to carry on.
> 
> I only have a vague idea of this, because I never have experience on it.
> 

	I agree that have one is better than nothing .The testing certainly
will help to improve the work of hpfsc.

> My point is that there is no necessary to prove that we have a complete
> semantics checking, but we can say we have a complete enought one. Just like
> syntax checking. We just try to touch each syntax rules at least once, but
> there endless combinations we can not afford to test.
> 
> Could you write a little more on semantics checking? What I want is a more
> complete technical report like the one about syntax checking I send to you. I
> think based on so many work you have done. You should be able to write a prety
> good one. In fact I don't want loose this chance to others.
>

	I am willing to try , but now we are having final exams these days.
I think I will have free time next week . 

> If you are also too busy or have no interests on this, we have to let it go.
> But I hope you can spend one or two days to try it.
> 
> Give me a response about this. Any thing you are not sure just ask. I will do
> my best to help you.
> 

	The difficulty is that I am not familiar with how to write by latex .

Gengbin